/************************************************************************
Simple Form Mail Project        http://www.qDecoder.org/projects/qmailer/
qDecoder - C/C++ CGI Library                      http://www.qDecoder.org

Copyright (C) 2001 The qDecoder Project.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Copyright Disclaimer:
  Dae-heung Park., hereby disclaims all copyright interest.
  Author, Dae-heung Park, 30 April 2001
************************************************************************/

#include	<stdio.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	"qDecoder.h"
#include "qInternal.h"
#include	"qSendmail.h"
#include	"qMailer.h"

#define	REALTIME_CONF		"qMailer.conf"
#define	QMAILER_HEAD		"_head.chtml"
#define	QMAILER_FORM		"_form.chtml"
#define	QMAILER_SEND		"_send.chtml"
#define	QMAILER_POST		"_post.chtml"
#define	QMAILER_TAIL		"_tail.chtml"

static SMTP_RESULT	smtp_result;
static SMTP_CHANNEL	smtp_channel;
static QMAILER_CONF	conf;

void	getConf();
void	formMail();
void	previewMail();
void	sendMail();
void	postMail(Q_Entry* args, Q_Entry* qArgs);
int	inputCheck();

// The Entry of App.
int main()
{
	qDecoder();
	getConf();
	qContentType("text/html");

	if (qValue("mode") == NULL || strcmp(qValue("mode"), "form") == 0)
	{
		formMail();
	}
	else if (strcmp(qValue("mode"), "preview") == 0)
	{
		qError("̸    ʽϴ.");
	}
	else if (strcmp(qValue("mode"), "send") == 0)
	{
		inputCheck();
		sendMail();
	}

	qFree();

	return	1;
}

void formMail()
{
	Q_Entry*	args;
	Q_Entry*	qArgs;
	char	skinpath[256];
	char*	pCGIMode;

	pCGIMode = "send";
	args = NULL;
	args = qSedArgAppend(args, "${QMAILER_URL}",       "");
	args = qSedArgAppend(args, "${CGI}",               qCGIname());
	args = qSedArgAppend(args, "${CGI_MODE}",          pCGIMode);
	args = qSedArgAppend(args, "${SKIN}",              conf.pszDefaultSkin);
	args = qSedArgAppend(args, "${TO_NAME_OPEN}",      conf.pszToNameOpen);
	args = qSedArgAppend(args, "${TO_NAME_MODE}",      conf.pszToNameMode);
	args = qSedArgAppend(args, "${TO_NAME_CLOSE}",     conf.pszToNameClose);
	args = qSedArgAppend(args, "${FROM_NAME_OPEN}",    conf.pszFromNameOpen);
	args = qSedArgAppend(args, "${FROM_NAME_MODE}",    conf.pszFromNameMode);
	args = qSedArgAppend(args, "${FROM_NAME_CLOSE}",   conf.pszFromNameClose);
	args = qSedArgAppend(args, "${CC_OPEN}",           conf.pszCCOpen);
	args = qSedArgAppend(args, "${CC_MODE}",           conf.pszCCMode);
	args = qSedArgAppend(args, "${CC_CLOSE}",          conf.pszCCClose);
	args = qSedArgAppend(args, "${BCC_OPEN}",          conf.pszBCCOpen);
	args = qSedArgAppend(args, "${BCC_MODE}",          conf.pszBCCMode);
	args = qSedArgAppend(args, "${BCC_CLOSE}",         conf.pszBCCClose);
	args = qSedArgAppend(args, "${HTML_FILE_OPEN}",    conf.pszHTMLFileOpen);
	args = qSedArgAppend(args, "${HTML_FILE_MODE}",    conf.pszHTMLFileMode);
	args = qSedArgAppend(args, "${HTML_FILE_CLOSE}",   conf.pszHTMLFileClose);
	args = qSedArgAppend(args, "${ATTACH_FILE_OPEN}",  conf.pszAttachFileOpen);
	args = qSedArgAppend(args, "${ATTACH_FILE_MODE}",  conf.pszAttachFileMode);
	args = qSedArgAppend(args, "${ATTACH_FILE_CLOSE}", conf.pszAttachFileClose);

	if(!strcmp(conf.pszSubjectPrefix, "true"))
	{
		args = qSedArgAppend(args, "${SUBJECT_PREFIX}", "value='%s' readonly", conf.pszSubject);
	}
	else
	{
		args = qSedArgAppend(args, "${SUBJECT_PREFIX}", "");
	}

	args = qSedArgAppend(args, "${SUBMIT_MODE}",       conf.pszSubmitMode);
	if(!strcmp(conf.pszSubmitMode, "image"))
	{
		args = qSedArgAppend(args, "${SUBMIT}",         "src='%s/%s/%s'", conf.pszSkinDirectory, conf.pszDefaultSkin, conf.pszSubmitSkinImage);
	}
	else
	{
		args = qSedArgAppend(args, "${SUBMIT}",         "value='&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'");
	}

	qArgs = NULL;
	qArgs = qSedArgAppend(qArgs, "${QMAILER_URL}",     "");

	sprintf(skinpath, "%s/%s/%s%s", conf.pszSkinDirectory, conf.pszDefaultSkin, conf.pszDefaultSkin, QMAILER_HEAD);
	if(qSedFile(qArgs, skinpath, stdout) == 0)	qError("File(%s) not found.", skinpath);
	sprintf(skinpath, "%s/%s/%s%s", conf.pszSkinDirectory, conf.pszDefaultSkin, conf.pszDefaultSkin, QMAILER_FORM);
	if(qSedFile(args,  skinpath, stdout) == 0)	qError("File(%s) not found.", skinpath);
	sprintf(skinpath, "%s/%s/%s%s", conf.pszSkinDirectory, conf.pszDefaultSkin, conf.pszDefaultSkin, QMAILER_TAIL);
	if(qSedFile(qArgs, skinpath, stdout) == 0)	qError("File(%s) not found.", skinpath);
	
	qSedArgFree(qArgs);
	qSedArgFree(args);
}

void sendMail()
{
	HEADER	header;
	DATUM		attach;
	Q_Entry*	args;
	Q_Entry*	qArgs;
	char	skinpath[256];
	char*	pMailHeader;
	char*	pMailFooter;
	char*	pHTML;
	char*	pHTMLFile;
	char*	pszMessage;
	char*	pszBody;
	int	iSize;

	pMailHeader = pMailFooter = NULL;
	if(!strcmp(conf.pszMailHeaderOption, "true"))	pMailHeader = qReadFile(conf.pszMailHeader, NULL);
	if(!strcmp(conf.pszMailFooterOption, "true"))	pMailFooter = qReadFile(conf.pszMailFooter, NULL);
	if(!pMailHeader)	pMailHeader = "";
	if(!pMailFooter)	pMailFooter = "";

	if(!strcmp(conf.pszBodyToHTML, "true"))	pHTML = qHtmlize(qValue("qBody"));
	else													pHTML = qValue("qBody");
	if(!pHTML)	pHTML = "";
	pHTMLFile = qValue("qHTMLFile");
	iSize = strlen(pMailHeader)+strlen(pMailFooter)+strlen(pHTML)+qiValue("qHTMLFile.length");
	pszMessage = (char*) malloc(iSize+256);
	pszBody = (char*) malloc(iSize+256+10240);
	
	sprintf(pszMessage, "%s%s", pHTML, pHTMLFile?pHTMLFile:"");

	args = NULL;
	args = qSedArgAppend(args, "${QMAILER_URL}",       conf.pszQMailerURL);
	args = qSedArgAppend(args, "${TO}",                qValue("qTo")?qRemoveSpace(qValue("qTo")):"");
	args = qSedArgAppend(args, "${TO_NAME_OPEN}",      conf.pszToNameOpen);
	args = qSedArgAppend(args, "${TO_NAME}",           qValue("qToName")?qRemoveSpace(qValue("qToName")):"");
	args = qSedArgAppend(args, "${TO_NAME_CLOSE}",     conf.pszToNameClose);
	args = qSedArgAppend(args, "${FROM}",              qValue("qFrom")?qRemoveSpace(qValue("qFrom")):"");
	args = qSedArgAppend(args, "${FROM_NAME_OPEN}",    conf.pszFromNameOpen);
	args = qSedArgAppend(args, "${FROM_NAME}",         qValue("qFromName")?qRemoveSpace(qValue("qFromName")):"");
	args = qSedArgAppend(args, "${FROM_NAME_CLOSE}",   conf.pszFromNameClose);
	args = qSedArgAppend(args, "${CC_OPEN}",           conf.pszCCOpen);
	args = qSedArgAppend(args, "${CC}",                qValue("qCC")?qRemoveSpace(qValue("qCC")):"");
	args = qSedArgAppend(args, "${CC_CLOSE}",          conf.pszCCClose);
	args = qSedArgAppend(args, "${BCC_OPEN}",          conf.pszBCCOpen);
	args = qSedArgAppend(args, "${BCC}",               qValue("qBCC")?qRemoveSpace(qValue("qBCC")):"");
	args = qSedArgAppend(args, "${BCC_CLOSE}",         conf.pszBCCClose);
	args = qSedArgAppend(args, "${SUBJECT}",           qRemoveSpace(qValue("qSubject")));

	args = qSedArgAppend(args, "${HTML_FILE_OPEN}",    conf.pszHTMLFileOpen);
	if(qValue("qHTMLFile.filename"))
	{
	args = qSedArgAppend(args, "${HTML_FILE_NAME}",    qValue("qHTMLFile.filename"));
	args = qSedArgAppend(args, "${HTML_FILE_SIZE}",    "%.2f Kbytes", qiValue("qHTMLFile.length")/1024.0);
	}
	else
	{
	args = qSedArgAppend(args, "${HTML_FILE_NAME}",    "");
	args = qSedArgAppend(args, "${HTML_FILE_SIZE}",    "");
	}
	args = qSedArgAppend(args, "${HTML_FILE_CLOSE}",   conf.pszHTMLFileClose);

	args = qSedArgAppend(args, "${ATTACH_FILE_OPEN}",  conf.pszAttachFileOpen);
	if(qValue("qAttachFile.filename"))
	{
	args = qSedArgAppend(args, "${ATTACH_FILE_NAME}",  qValue("qAttachFile.filename"));
	args = qSedArgAppend(args, "${ATTACH_FILE_SIZE}",  "%.2f Kbytes", qiValue("qAttachFile.length")/1024.0);
	}
	else
	{
	args = qSedArgAppend(args, "${ATTACH_FILE_NAME}",  "");
	args = qSedArgAppend(args, "${ATTACH_FILE_SIZE}",  "");
	}
	args = qSedArgAppend(args, "${ATTACH_FILE_CLOSE}", conf.pszAttachFileClose);

	args = qSedArgAppend(args, "${MAIL_HEADER}",       pMailHeader);
	args = qSedArgAppend(args, "${MAIL_FOOTER}",       pMailFooter);
	args = qSedArgAppend(args, "${BODY}",              pHTML);
	args = qSedArgAppend(args, "${MESSAGE}",           pszMessage);

	qArgs = NULL;
	qArgs = qSedArgAppend(qArgs, "${QMAILER_URL}",     conf.pszQMailerURL);

	sprintf(skinpath, "%s/%s/%s%s", conf.pszSkinDirectory, conf.pszDefaultSkin, conf.pszDefaultSkin, QMAILER_HEAD);
	if(qSedString(qArgs, skinpath, &pszBody[0]) == 0)						qError("File(%s) not found.", skinpath);
	sprintf(skinpath, "%s/%s/%s%s", conf.pszSkinDirectory, conf.pszDefaultSkin, conf.pszDefaultSkin, QMAILER_SEND);
	if(qSedString(args,  skinpath, &pszBody[strlen(pszBody)]) == 0)	sprintf(&pszBody[strlen(pszBody)], "%s%s%s", pMailHeader, pszMessage, pMailFooter);
	sprintf(skinpath, "%s/%s/%s%s", conf.pszSkinDirectory, conf.pszDefaultSkin, conf.pszDefaultSkin, QMAILER_TAIL);
	if(qSedString(qArgs, skinpath, &pszBody[strlen(pszBody)]) == 0)	qError("File(%s) not found.", skinpath);

	header.pszFrom     = qRemoveSpace(qValue("qFrom"));
	header.pszFromName = qRemoveSpace(qValue("qFromName"));
	header.pszTo       = qRemoveSpace(qValue("qTo"));
	header.pszToName   = qRemoveSpace(qValue("qToName"));
	header.pszCc       = qRemoveSpace(qValue("qCC"));
	header.pszBcc      = qRemoveSpace(qValue("qBCC"));
	header.pszXMailer  = conf.pszVersion;
	header.pszSubject  = qRemoveSpace(qValue("qSubject"));
	if(!header.pszFromName)	header.pszFromName = "";
	if(!header.pszToName)	header.pszToName   = "";
	if(!header.pszCc)			header.pszCc       = "";
	if(!header.pszBcc)		header.pszBcc      = "";

	attach.dsize = qiValue("qAttachFile.length");
	attach.dname = qValue("qAttachFile.filename");
	attach.dptr  = qValue("qAttachFile");

	qSendmail( &smtp_result, smtp_channel, header, qMailize(pszBody), attach );

	args = qSedArgAppend(args, "${SMTP_ERROR}", "%s",  smtp_result.pszLastError);
	args = qSedArgAppend(args, "${SMTP_SEND}",  "%s",  smtp_result.pDeliveredList);
	postMail( args, qArgs );

	free(pszBody);
	free(pszMessage);
	qSedArgFree(qArgs);
	qSedArgFree(args);
}

void postMail(Q_Entry* args, Q_Entry* qArgs)
{
	char	skinpath[256];

	sprintf(skinpath, "%s/%s/%s%s", conf.pszSkinDirectory, conf.pszDefaultSkin, conf.pszDefaultSkin, QMAILER_HEAD);
	if(qSedFile(qArgs, skinpath, stdout) == 0)	qError("File(%s) not found.", skinpath);
	sprintf(skinpath, "%s/%s/%s%s", conf.pszSkinDirectory, conf.pszDefaultSkin, conf.pszDefaultSkin, QMAILER_POST);
	if(qSedFile(args,  skinpath, stdout) == 0)	qError("File(%s) not found.", skinpath);
	sprintf(skinpath, "%s/%s/%s%s", conf.pszSkinDirectory, conf.pszDefaultSkin, conf.pszDefaultSkin, QMAILER_TAIL);
	if(qSedFile(qArgs, skinpath, stdout) == 0)	qError("File(%s) not found.", skinpath);
}

void getConf()
{
	Q_Entry*	pConf;
	char		confpath[256];

	pConf = qfDecoder(REALTIME_CONF);
	if(pConf == NULL) qError("configuration file(%s) not found.", REALTIME_CONF);

	smtp_channel.pszServer = qfValue(pConf,  "Server");
	smtp_channel.iPort     = qfiValue(pConf, "Port");
	smtp_channel.pszDomain = qfValue(pConf,  "Domain");
	if(!smtp_channel.pszServer)	smtp_channel.pszServer = "";
	if(!smtp_channel.pszDomain)	smtp_channel.pszDomain = "";

	conf.pszVersion       = qfValue(pConf,  "ProgramVersion");
	conf.pszQMailerURL    = qfValue(pConf,  "QMailerURL");
	conf.pszSkinDirectory = qfValue(pConf,  "SkinDirectory");
	if(qValue("skin"))
	{
	conf.pszDefaultSkin          = qRemoveSpace(qValue("skin"));
	}
	else
	{
	conf.pszDefaultSkin          = qfValue(pConf, "DefaultSkin");
	}
	conf.pszMailHeader    = qfValue(pConf,  "MailHeader");
	conf.pszMailFooter    = qfValue(pConf,  "MailFooter");
	if(!conf.pszVersion)			conf.pszVersion       = "qMailer-x.x.x-unknown version";
	if(!conf.pszQMailerURL)		conf.pszQMailerURL    = "";
	if(!conf.pszSkinDirectory)	conf.pszSkinDirectory = "skin";
	if(!conf.pszDefaultSkin)	conf.pszDefaultSkin   = "default";
	if(!conf.pszMailHeader)		conf.pszMailHeader    = "message/mailheader.txt";
	if(!conf.pszMailFooter)		conf.pszMailFooter    = "message/mailfooter.txt";

	sprintf(confpath, "%s/%s/%s.conf", conf.pszSkinDirectory, conf.pszDefaultSkin, conf.pszDefaultSkin);
	pConf = qfDecoder(confpath);
	if(pConf == NULL) qError("configuration file(%s) not found.", confpath);

	conf.pszBodyToHTML       = qfValue(pConf,  "BodyToHTML");
	conf.pszMailHeaderOption = qfValue(pConf,  "MailHeaderOption");
	conf.pszMailFooterOption = qfValue(pConf,  "MailFooterOption");
	conf.pszSubjectPrefix    = qfValue(pConf,  "SubjectPrefix");
	conf.pszSubject          = qfValue(pConf,  "Subject");
	if(!conf.pszBodyToHTML)			conf.pszBodyToHTML       = "true";
	if(!conf.pszMailHeaderOption)	conf.pszMailHeaderOption = "false";
	if(!conf.pszMailFooterOption)	conf.pszMailFooterOption = "false";
	if(!conf.pszSubjectPrefix)		conf.pszSubjectPrefix    = "false";
	if(!conf.pszSubject)				conf.pszSubject          = "[qMailer] ̸    ֽʽÿ.";

	conf.pszToNameMode     = qfValue(pConf, "TO_NAME_MODE");
	conf.pszFromNameMode   = qfValue(pConf, "FROM_NAME_MODE");
	conf.pszCCMode         = qfValue(pConf, "CC_MODE");
	conf.pszBCCMode        = qfValue(pConf, "BCC_MODE");
	conf.pszHTMLFileMode   = qfValue(pConf, "HTML_FILE_MODE");
	conf.pszAttachFileMode = qfValue(pConf, "ATTACH_FILE_MODE");
	if(!conf.pszToNameMode)			conf.pszToNameMode     = "text";
	if(!conf.pszFromNameMode)		conf.pszFromNameMode   = "text";
	if(!conf.pszCCMode)				conf.pszCCMode         = "text";
	if(!conf.pszBCCMode)				conf.pszBCCMode        = "text";
	if(!conf.pszHTMLFileMode)		conf.pszHTMLFileMode   = "file";
	if(!conf.pszAttachFileMode)	conf.pszAttachFileMode = "file";

	conf.pszToNameOpen     = "",	conf.pszToNameClose     = "";
	conf.pszFromNameOpen   = "",	conf.pszFromNameClose   = "";
	conf.pszCCOpen         = "",	conf.pszCCClose         = "";
	conf.pszBCCOpen        = "",	conf.pszBCCClose        = "";
	conf.pszHTMLFileOpen   = "",	conf.pszHTMLFileClose   = "";
	conf.pszAttachFileOpen = "",	conf.pszAttachFileClose = "";
	if(strcmp(conf.pszToNameMode,     "text"))	conf.pszToNameOpen     = "<!--",	conf.pszToNameClose     = "-->";
	if(strcmp(conf.pszFromNameMode,   "text"))	conf.pszFromNameOpen   = "<!--",	conf.pszFromNameClose   = "-->";
	if(strcmp(conf.pszCCMode,         "text"))	conf.pszCCOpen         = "<!--",	conf.pszCCClose         = "-->";
	if(strcmp(conf.pszBCCMode,        "text"))	conf.pszBCCOpen        = "<!--",	conf.pszBCCClose        = "-->";
	if(strcmp(conf.pszHTMLFileMode,   "file"))	conf.pszHTMLFileOpen   = "<!--",	conf.pszHTMLFileClose   = "-->";
	if(strcmp(conf.pszAttachFileMode, "file"))	conf.pszAttachFileOpen = "<!--",	conf.pszAttachFileClose = "-->";

	conf.pszSubmitMode         = qfValue(pConf, "SUBMIT_MODE");
	conf.pszSubmitSkinImage    = qfValue(pConf, "SUBMIT_SKIN_IMAGE");
	if(!conf.pszSubmitMode)			conf.pszSubmitMode         = "submit";
	if(!conf.pszSubmitSkinImage)	conf.pszSubmitSkinImage    = "submit_skin.gif";
}

int inputCheck()
{
	Q_Entry*	pList;
	char*	pFrom    = qRemoveSpace(qValue("qFrom"));
	char*	pTo      = qRemoveSpace(qValue("qTo"));
	char*	pCc      = qRemoveSpace(qValue("qCC"));
	char*	pBcc     = qRemoveSpace(qValue("qBCC"));
	char*	pSubject = qRemoveSpace(qValue("qSubject"));
	char*	pEmail;
	int	i;
	int	iResult = 0;

	if(!pFrom)						qError(" (qFrom) ׸ ϴ.");
	if(!strcmp(pFrom, ""))		qError(" (qFrom) E-mail ּҸ Էϼ.");
	if(!qCheckEmail(pFrom))		qError(" (qFrom) E-mail () ùٸ E-mail ּҰ ƴմϴ.");

	if(!pTo)							qError("޴ (qTo) ׸ ϴ.");
	if(!strcmp(pTo, ""))			qError("޴ (qTo) E-mail ּҸ Էϼ.");
	if(!qCheckEmail(pTo))		qError("޴ (qTo) E-mail () ùٸ E-mail ּҰ ƴմϴ.");

	if(pCc && strcmp(pCc, ""))
	{
		pList = qsList(pCc, ',');
		i = 0;
		while( (pEmail = qsValue(pList, "%d", i)) != NULL )
		{
			if(!qCheckEmail(pEmail))	qError("(qCC) %s E-mail () ùٸ E-mail ּҰ ƴմϴ.", pEmail);
			i++;
		}
		qsFree(pList);
	}
	if(pBcc && strcmp(pBcc, ""))
	{
		pList = qsList(pBcc, ',');
		i = 0;
		while( (pEmail = qsValue(pList, "%d", i)) != NULL )
		{
			if(!qCheckEmail(pEmail))	qError(" (qBCC) %s E-mail () ùٸ E-mail ּҰ ƴմϴ.", pEmail);
			i++;
		}
		qsFree(pList);
	}

	if(!pSubject)					qError("(subject) ׸ ϴ.");
	if(!strcmp(pSubject, ""))	qError(" Էϼ.");

	iResult = 1;

	return	iResult;
}

/**********************************************
** Usage : qHtmlize(mode, string pointer);
** Do    : print HTML link as multi mode.
**         Mode 0  : Same as printf()
**         Mode 1  : Print HTML TAG
**         Mode 2  : Mode 1 + Auto Link
**         Mode 3  : Mode 2 + Auto Link to _top frame
**         Mode 4  : Waste HTML TAG
**         Mode 5  : Mode 4 + Auto Link
**         Mode 6  : Mode 5 + Auto Link to _top frame
**
**         Mode 10  :Mode 0 + Convert
**         Mode 11 : Print HTML TAG + Convert
**         Mode 12 : Mode 11 + Auto Link
**         Mode 13 : Mode 12 + Auto Link to _top frame
**         Mode 14 : Waste HTML TAG + Convert
**         Mode 15 : Mode 14 + Auto Link
**         Mode 16 : Mode 15 + Auto Link to _top frame
**
**         Convert : " "   -> " "
**                   "  "  -> " &nbsp;"
**                   "   " -> " &nbsp;&nbsp;"
**                   "\n"   -> "<br>\n"
**                   "\r\n" -> "<br>\n"
**
** You can use 1x mode, to wrap long lines with no <pre> tag.
** Note) It modify argument string.
**********************************************/
char* qHtmlize(char *buf) {
  int		i;
  int		iIndex;
  int		iSize;
  char*	sp;

  if((buf == NULL) || buf[0] == 0x00) return NULL;

  iSize = 2*strlen(buf)+1024;
  sp = (char*) malloc(2*strlen(buf)+1024);
  iIndex = 0;
  for(i = 0; (buf[i] != 0x00) && (iIndex < (iSize-8)); i++) {
    switch(buf[i]) {
      case ' '  : {
        if((i > 0) && (buf[i - 1] == ' ')) iIndex += sprintf(&sp[iIndex], "&nbsp;");
        else iIndex += sprintf(&sp[iIndex], " ");
        break;
      }
      case '\r' : {
        break;
      }
      case '\n' : {
        iIndex += sprintf(&sp[iIndex], "<br>\n");
        break;
      }
      default   : {
        iIndex += sprintf(&sp[iIndex], "%c", buf[i]);
        break;
      }
    }
  }

  return sp;
}

char* qMailize(char *buf) {
  int		i;
  int		iIndex;
  int		iSize;
  char*	sp;
  
  if(buf == NULL) return NULL;

  iSize = strlen(buf)+1024;
  sp = (char*) malloc(iSize);
  iIndex = 0;
  for(i = 0; (buf[i] != '\0') && (iIndex < (iSize-8)); i++) {
    switch(buf[i]) {
      case '\n' : {
        if((i > 0) && (buf[i - 1] == '\r')) iIndex += sprintf(&sp[iIndex], "\n");
        else                                iIndex += sprintf(&sp[iIndex], "\r\n");
        break;
      }
      default   : {
        iIndex += sprintf(&sp[iIndex], "%c", buf[i]);
        break;
      }
    }
  }
    
  return sp;
}

#define	SSI_INCLUDE_START	"<!--#include file=\""
#define SSI_INCLUDE_END		"\"-->"

static int
int_vasprintf (result, format, args)
     char **result;
     const char *format;
     va_list *args;
{
  const char *p = format;
  /* Add one to make sure that it is never zero, which might cause malloc
     to return NULL.  */
  int total_width = strlen (format) + 1;
  va_list ap;

//  memcpy ((PTR) &ap, (PTR) args, sizeof (va_list));
  memcpy (&ap, args, sizeof (va_list));

  while (*p != '\0')
    {
      if (*p++ == '%')
	{
	  while (strchr ("-+ #0", *p))
	    ++p;
	  if (*p == '*')
	    {
	      ++p;
	      total_width += abs (va_arg (ap, int));
	    }
	  else
	    total_width += strtoul (p, (char **) &p, 10);
	  if (*p == '.')
	    {
	      ++p;
	      if (*p == '*')
		{
		  ++p;
		  total_width += abs (va_arg (ap, int));
		}
	      else
	      total_width += strtoul (p, (char **) &p, 10);
	    }
	  while (strchr ("hlL", *p))
	    ++p;
	  /* Should be big enough for any format specifier except %s and floats.  */
	  total_width += 30;
	  switch (*p)
	    {
	    case 'd':
	    case 'i':
	    case 'o':
	    case 'u':
	    case 'x':
	    case 'X':
	    case 'c':
	      (void) va_arg (ap, int);
	      break;
	    case 'f':
	    case 'e':
	    case 'E':
	    case 'g':
	    case 'G':
	      (void) va_arg (ap, double);
	      /* Since an ieee double can have an exponent of 307, we'll
		 make the buffer wide enough to cover the gross case. */
	      total_width += 307;
	      break;
	    case 's':
	      total_width += strlen (va_arg (ap, char *));
	      break;
	    case 'p':
	    case 'n':
	      (void) va_arg (ap, char *);
	      break;
	    }
	  p++;
	}
    }
#ifdef TEST
  global_total_width = total_width;
#endif
  *result = malloc (total_width);
  if (*result != NULL)
    return vsprintf (*result, format, *args);
  else
    return 0;
}

/**********************************************
** Usage : qSedArgAppend(entry pointer, name, value);
** Do    : Add given name and value to linked list.
**         If same name exists, it'll be replaced.
**
** ex) qValueAppend("NAME", "Seung-young Kim");
**********************************************/
Q_Entry *qSedArgAppend(Q_Entry *first, char *name, char *format, ...) {
  Q_Entry *new_entry;
  char* value;
  int status;
  va_list arglist;

  if(!strcmp(name, "")) qError("qSedArgAppend(): can not add empty name.");

  va_start(arglist, format);
  status = int_vasprintf(&value, format, &arglist);
  if(status == EOF) qError("qSedArgAppend(): Message is too long or invalid. %s : %d : %d", name, strlen(value), sizeof(value));
  va_end(arglist);

  new_entry = _EntryAdd(first, name, value);
  if(!first) first = new_entry;
  
  return first;
}

/**********************************************
** Usage : qSedString(Entry pointer, filename, pString);
** Return: Success 1, Fail open fail 0.
** Do    : Stream Editor.
**********************************************/
int qSedString(Q_Entry* first, char* filename, char* pString) {
  Q_Entry *entries;
  char *sp;
  int iIndex = 0;
  char *srcstr;

  if((srcstr = qReadFile(filename, NULL)) == NULL) return 0;
  if(pString == NULL) return 0;

  /* Parsing */
  for(sp = srcstr; *sp != '\0'; sp++) {
    int flag;

    /* SSI invocation */
    if(!strncmp(sp, SSI_INCLUDE_START, strlen(SSI_INCLUDE_START))) {
      char ssi_inc_file[1024], *endp;
      if((endp = strstr(sp, SSI_INCLUDE_END)) != NULL) {
        sp += strlen(SSI_INCLUDE_START);
        strncpy(ssi_inc_file, sp, endp - sp);
        ssi_inc_file[endp-sp] = '\0';
        sp = (endp + strlen(SSI_INCLUDE_END)) - 1;

        if(qCheckFile(ssi_inc_file) == 1) iIndex += sprintf(&pString[iIndex], "%s", qReadFile(ssi_inc_file, NULL));
        else printf("[qSedStr: an error occurred while processing 'include' directive - file(%s) open fail]", ssi_inc_file);
      }
      else printf("[qSedStr: an error occurred while processing 'include' directive - ending tag not found]");
      continue;
    }

    /* Pattern Matching */
    for(entries = first, flag = 0; entries && flag == 0; entries = entries->next) {
      if(!strncmp(sp, entries->name, strlen(entries->name))) {
        iIndex += sprintf(&pString[iIndex], "%s", entries->value);
        sp += strlen(entries->name) - 1;
        flag = 1;
      }
    }
    if(flag == 0) iIndex += sprintf(&pString[iIndex], "%c", *sp);
  }

  free(srcstr);

  return 1;
}
